namespace Parsing.Schema.BuildingBlocks;

using Parsing.Tokenization;

class LongBlock : BuildingBlockBase
{

    public LongBlock()
    {
    }

    public override List<IToken> ParseWord(InputProvider inputs)
    {
        return new List<IToken>() { new LongToken(inputs.YieldWord()) };
    }

    public override bool CanParseWord(InputProvider inputs)
    {
        using (inputs.GetLookaheadContext())
        {
            return this.CanParseWord(inputs.YieldWord());
        }
    }

    public override bool CanParseWord(string word)
    {
        long number = 0;
        return long.TryParse(word, out number);
    }

    public override BlockType GetBlockType()
    {
        return BlockType.Long;
    }
}