﻿namespace Parsing.Tokenization;

using Parsing.Schema;

public class LongToken : IValueToken<long>
{
    private string word;

    public LongToken(string word)
    {
        this.word = word;
    }

    public string GetText()
    {
        return word;
    }

    public long GetValue()
    {
        return long.Parse(word);
    }

    public InputType GetInputType()
    {
        return InputType.Long;
    }
}
